unit OneSound;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, openal, StdCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  buffer : TALuint;
  source : TALuint;

//  // Determine a position in 3d space for our source
//  sourcepos: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0 );
//  // Set the velocity of our source to be zero for all axes (i.e. stationary)
//  sourcevel: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0 );
//  // Similarly, set up positional info for the listener
//  listenerpos: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0);
//  listenervel: array [0..2] of TALfloat= ( 0.0, 0.0, 0.0);
//  // We also set the orientation of the listener
//  listenerori: array [0..5] of TALfloat= ( 0.0, 0.0, -1.0, 0.0, 1.0, 0.0);

implementation

{$R *.dfm}

procedure TForm2.Button1Click(Sender: TObject);
begin
  alSourcePlay(source);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if ((Sender as TButton).Caption = 'Loop') then
  begin
    (Sender as TButton).Caption := 'End Loop';
    alSourcei(source, AL_LOOPING, AL_TRUE);
  end else begin
    (Sender as TButton).Caption := 'Loop';
    alSourcei(source, AL_LOOPING, AL_FALSE);
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  alSourceStop(source);
end;

procedure TForm2.Button4Click(Sender: TObject);
begin
  alSourcePause(source);
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  argv: array of PalByte;
  format: TALEnum;
  size: TALSizei;
  freq: TALSizei;
  loop: TALInt;
  data: TALVoid;
begin
  // Initialise the OpenAL library.
  InitOpenAL;
  alutInit(nil, argv);

  // Create a buffer to hold sound data loaded from a file
  alGenBuffers(1, @buffer);
  // Load data from the sound file
  alutLoadWAVFile('ding.wav', format, data, size, freq, loop);
  // Pass the loaded buffer to OpenAL
  alBufferData(buffer, format, data, size, freq);
  // Once the data buffer is passed to OpenAL we no longer need the sound file
  // so it can be unloaded
  alutUnloadWAV(format, data, size, freq);

  // Before we can hear the sound we have to attach it to a source

  // First we generate a source in OpenAL
  alGenSources(1, @source);
  // Next we attach the buffer, that we populated earlier, to this source
  alSourcei(source, AL_BUFFER, buffer);
//  // We can also make sure of some other default values.  Pitch determines how high
//  // the sound is & Gain determines how loud.
//  alSourcef(source, AL_PITCH, 1.0 );
//  alSourcef(source, AL_GAIN, 1.0 );
//  // Now we set the position and velocity for the source
//  alSourcefv(source, AL_POSITION, @sourcepos);
//  alSourcefv(source, AL_VELOCITY, @sourcevel);
//  // We ensure that the source is not looping
//  alSourcei(source, AL_LOOPING, loop);
//
//  // Now we set where we are listening from along with the listener's velocity
//  // and orientation
//  alListenerfv(AL_POSITION, @listenerpos);
//  alListenerfv(AL_VELOCITY, @listenervel);
//  alListenerfv(AL_ORIENTATION, @listenerori);
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  alSourceStop(source);
  alDeleteBuffers(1, @buffer);
  alDeleteSources(1, @source);
  alutExit;
end;

end.
